<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:12 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>CopySpec (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="CopySpec (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/file/CopySourceSpec.html" title="interface in org.gradle.api.file"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/file/DeleteSpec.html" title="interface in org.gradle.api.file"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/file/CopySpec.html" target="_top">Frames</a></li>
<li><a href="CopySpec.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.api.file</div>
<h2 title="Interface CopySpec" class="title">Interface CopySpec</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Superinterfaces:</dt>
<dd><a href="../../../../org/gradle/api/file/ContentFilterable.html" title="interface in org.gradle.api.file">ContentFilterable</a>, <a href="../../../../org/gradle/api/file/CopyProcessingSpec.html" title="interface in org.gradle.api.file">CopyProcessingSpec</a>, <a href="../../../../org/gradle/api/file/CopySourceSpec.html" title="interface in org.gradle.api.file">CopySourceSpec</a>, <a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util">PatternFilterable</a></dd>
</dl>
<dl>
<dt>All Known Implementing Classes:</dt>
<dd><a href="../../../../org/gradle/api/tasks/bundling/AbstractArchiveTask.html" title="class in org.gradle.api.tasks.bundling">AbstractArchiveTask</a>, <a href="../../../../org/gradle/api/tasks/AbstractCopyTask.html" title="class in org.gradle.api.tasks">AbstractCopyTask</a>, <a href="../../../../org/gradle/api/tasks/Copy.html" title="class in org.gradle.api.tasks">Copy</a>, <a href="../../../../org/gradle/plugins/ear/Ear.html" title="class in org.gradle.plugins.ear">Ear</a>, <a href="../../../../org/gradle/jvm/tasks/Jar.html" title="class in org.gradle.jvm.tasks">Jar</a>, <a href="../../../../org/gradle/api/tasks/bundling/Jar.html" title="class in org.gradle.api.tasks.bundling">Jar</a>, <a href="../../../../org/gradle/language/jvm/tasks/ProcessResources.html" title="class in org.gradle.language.jvm.tasks">ProcessResources</a>, <a href="../../../../org/gradle/api/tasks/Sync.html" title="class in org.gradle.api.tasks">Sync</a>, <a href="../../../../org/gradle/api/tasks/bundling/Tar.html" title="class in org.gradle.api.tasks.bundling">Tar</a>, <a href="../../../../org/gradle/api/tasks/bundling/War.html" title="class in org.gradle.api.tasks.bundling">War</a>, <a href="../../../../org/gradle/api/tasks/bundling/Zip.html" title="class in org.gradle.api.tasks.bundling">Zip</a></dd>
</dl>
<hr>
<br>
<pre>public interface <span class="strong">CopySpec</span>
extends <a href="../../../../org/gradle/api/file/CopySourceSpec.html" title="interface in org.gradle.api.file">CopySourceSpec</a>, <a href="../../../../org/gradle/api/file/CopyProcessingSpec.html" title="interface in org.gradle.api.file">CopyProcessingSpec</a>, <a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util">PatternFilterable</a></pre>
<div class="block">A set of specifications for copying files.  This includes:

 <ul>

 <li>source directories (multiples allowed)

 <li>destination directory

 <li>ANT like include patterns

 <li>ANT like exclude patterns

 <li>File relocating rules

 <li>renaming rules

 <li>content filters

 </ul>

 CopySpecs may be nested by passing a closure to one of the from methods.  The closure creates a child CopySpec and
 delegates methods in the closure to the child. Child CopySpecs inherit any values specified in the parent. This
 allows constructs like:
 <pre class='autoTested'>
 def myCopySpec = project.copySpec {
   into('webroot')
   exclude('**&#47;.data/**')
   from('src/main/webapp') {
     include '**&#47;*.jsp'
   }
   from('src/main/js') {
     include '**&#47;*.js'
   }
 }
 </pre>

 In this example, the <code>into</code> and <code>exclude</code> specifications at the root level are inherited by the
 two child CopySpecs.

 Copy specs can be reused in other copy specs via <a href="../../../../org/gradle/api/file/CopySpec.html#with(org.gradle.api.file.CopySpec...)"><code>with(CopySpec...)</code></a> method. This enables reuse of the copy spec instances.

 <pre class='autoTested'>
 def contentSpec = copySpec {
   from("content") {
     include "**&#47;*.txt"
   }
 }

 task copy(type: Copy) {
   into "$buildDir/copy"
   with contentSpec
 }
 </pre></div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../org/gradle/api/tasks/Copy.html" title="class in org.gradle.api.tasks"><code>Copy Task</code></a>, 
<a href="../../../../org/gradle/api/Project.html#copy(groovy.lang.Closure)"><code>Project.copy()</code></a></dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#eachFile(org.gradle.api.Action)">eachFile</a></strong>(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file">FileCopyDetails</a>&gt;&nbsp;action)</code>
<div class="block">Adds an action to be applied to each file as it is about to be copied into its destination.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#eachFile(groovy.lang.Closure)">eachFile</a></strong>(<a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;closure)</code>
<div class="block">Adds an action to be applied to each file as it about to be copied into its destination.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#exclude(groovy.lang.Closure)">exclude</a></strong>(<a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;excludeSpec)</code>
<div class="block">Adds an exclude spec.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#exclude(java.lang.Iterable)">exclude</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;excludes)</code>
<div class="block">Adds an ANT style exclude pattern.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#exclude(org.gradle.api.specs.Spec)">exclude</a></strong>(<a href="../../../../org/gradle/api/specs/Spec.html" title="interface in org.gradle.api.specs">Spec</a>&lt;<a href="../../../../org/gradle/api/file/FileTreeElement.html" title="interface in org.gradle.api.file">FileTreeElement</a>&gt;&nbsp;excludeSpec)</code>
<div class="block">Adds an exclude spec.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#exclude(java.lang.String...)">exclude</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>...&nbsp;excludes)</code>
<div class="block">Adds an ANT style exclude pattern.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#expand(java.util.Map)">expand</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,?&gt;&nbsp;properties)</code>
<div class="block">Expands property references in each file as it is copied.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#filesMatching(java.lang.Iterable,%20org.gradle.api.Action)">filesMatching</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;patterns,
             <a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file">FileCopyDetails</a>&gt;&nbsp;action)</code>
<div class="block">Configure the <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file"><code>FileCopyDetails</code></a> for each file whose path matches any of the specified Ant-style patterns.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#filesMatching(java.lang.String,%20org.gradle.api.Action)">filesMatching</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;pattern,
             <a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file">FileCopyDetails</a>&gt;&nbsp;action)</code>
<div class="block">Configure the <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file"><code>FileCopyDetails</code></a> for each file whose path matches the specified Ant-style pattern.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#filesNotMatching(java.lang.Iterable,%20org.gradle.api.Action)">filesNotMatching</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;patterns,
                <a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file">FileCopyDetails</a>&gt;&nbsp;action)</code>
<div class="block">Configure the <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file"><code>FileCopyDetails</code></a> for each file whose path does not match any of the specified
 Ant-style patterns.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#filesNotMatching(java.lang.String,%20org.gradle.api.Action)">filesNotMatching</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;pattern,
                <a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file">FileCopyDetails</a>&gt;&nbsp;action)</code>
<div class="block">Configure the <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file"><code>FileCopyDetails</code></a> for each file whose path does not match the specified
 Ant-style pattern.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#filter(java.lang.Class)">filter</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="https://docs.oracle.com/javase/7/docs/api/java/io/FilterReader.html?is-external=true" title="class or interface in java.io">FilterReader</a>&gt;&nbsp;filterType)</code>
<div class="block">Adds a content filter to be used during the copy.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#filter(groovy.lang.Closure)">filter</a></strong>(<a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;closure)</code>
<div class="block">Adds a content filter based on the provided closure.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#filter(java.util.Map,%20java.lang.Class)">filter</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,?&gt;&nbsp;properties,
      <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="https://docs.oracle.com/javase/7/docs/api/java/io/FilterReader.html?is-external=true" title="class or interface in java.io">FilterReader</a>&gt;&nbsp;filterType)</code>
<div class="block">Adds a content filter to be used during the copy.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#filter(org.gradle.api.Transformer)">filter</a></strong>(<a href="../../../../org/gradle/api/Transformer.html" title="interface in org.gradle.api">Transformer</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;transformer)</code>
<div class="block">Adds a content filter based on the provided transformer.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#from(java.lang.Object...)">from</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>...&nbsp;sourcePaths)</code>
<div class="block">Specifies source files or directories for a copy.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#from(java.lang.Object,%20org.gradle.api.Action)">from</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;sourcePath,
    <a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&gt;&nbsp;configureAction)</code>
<div class="block">Specifies the source files or directories for a copy and creates a child <code>CopySpec</code>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#from(java.lang.Object,%20groovy.lang.Closure)">from</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;sourcePath,
    <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;c)</code>
<div class="block">Specifies the source files or directories for a copy and creates a child <code>CopySourceSpec</code>.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/DuplicatesStrategy.html" title="enum in org.gradle.api.file">DuplicatesStrategy</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#getDuplicatesStrategy()">getDuplicatesStrategy</a></strong>()</code>
<div class="block">Returns the strategy to use when trying to copy more than one file to the same destination.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#getFilteringCharset()">getFilteringCharset</a></strong>()</code>
<div class="block">Gets the charset used to read and write files when filtering.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#getIncludeEmptyDirs()">getIncludeEmptyDirs</a></strong>()</code>
<div class="block">Tells if empty target directories will be included in the copy.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#include(groovy.lang.Closure)">include</a></strong>(<a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;includeSpec)</code>
<div class="block">Adds an include spec.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#include(java.lang.Iterable)">include</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;includes)</code>
<div class="block">Adds an ANT style include pattern.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#include(org.gradle.api.specs.Spec)">include</a></strong>(<a href="../../../../org/gradle/api/specs/Spec.html" title="interface in org.gradle.api.specs">Spec</a>&lt;<a href="../../../../org/gradle/api/file/FileTreeElement.html" title="interface in org.gradle.api.file">FileTreeElement</a>&gt;&nbsp;includeSpec)</code>
<div class="block">Adds an include spec.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#include(java.lang.String...)">include</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>...&nbsp;includes)</code>
<div class="block">Adds an ANT style include pattern.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#into(java.lang.Object)">into</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;destPath)</code>
<div class="block">Specifies the destination directory for a copy.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#into(java.lang.Object,%20org.gradle.api.Action)">into</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;destPath,
    <a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&gt;&nbsp;copySpec)</code>
<div class="block">Creates and configures a child <code>CopySpec</code> with the given destination path.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#into(java.lang.Object,%20groovy.lang.Closure)">into</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;destPath,
    <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;configureClosure)</code>
<div class="block">Creates and configures a child <code>CopySpec</code> with the given destination path.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#isCaseSensitive()">isCaseSensitive</a></strong>()</code>
<div class="block">Specifies whether case-sensitive pattern matching should be used.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#rename(groovy.lang.Closure)">rename</a></strong>(<a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;closure)</code>
<div class="block">Renames a source file.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html" title="interface in org.gradle.api.file">CopyProcessingSpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#rename(java.util.regex.Pattern,%20java.lang.String)">rename</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/regex/Pattern.html?is-external=true" title="class or interface in java.util.regex">Pattern</a>&nbsp;sourceRegEx,
      <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;replaceWith)</code>
<div class="block">Renames files based on a regular expression.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#rename(java.lang.String,%20java.lang.String)">rename</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;sourceRegEx,
      <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;replaceWith)</code>
<div class="block">Renames files based on a regular expression.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#rename(org.gradle.api.Transformer)">rename</a></strong>(<a href="../../../../org/gradle/api/Transformer.html" title="interface in org.gradle.api">Transformer</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;renamer)</code>
<div class="block">Renames a source file.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#setCaseSensitive(boolean)">setCaseSensitive</a></strong>(boolean&nbsp;caseSensitive)</code>
<div class="block">Specifies whether case-sensitive pattern matching should be used for this CopySpec.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#setDuplicatesStrategy(org.gradle.api.file.DuplicatesStrategy)">setDuplicatesStrategy</a></strong>(<a href="../../../../org/gradle/api/file/DuplicatesStrategy.html" title="enum in org.gradle.api.file">DuplicatesStrategy</a>&nbsp;strategy)</code>
<div class="block">The strategy to use when trying to copy more than one file to the same destination.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#setExcludes(java.lang.Iterable)">setExcludes</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;excludes)</code>
<div class="block">Set the allowable exclude patterns.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#setFilteringCharset(java.lang.String)">setFilteringCharset</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;charset)</code>
<div class="block">Specifies the charset used to read and write files when filtering.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#setIncludeEmptyDirs(boolean)">setIncludeEmptyDirs</a></strong>(boolean&nbsp;includeEmptyDirs)</code>
<div class="block">Controls if empty target directories should be included in the copy.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#setIncludes(java.lang.Iterable)">setIncludes</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;includes)</code>
<div class="block">Set the allowable include patterns.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/file/CopySpec.html#with(org.gradle.api.file.CopySpec...)">with</a></strong>(<a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>...&nbsp;sourceSpecs)</code>
<div class="block">Adds the given specs as a child of this spec.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_org.gradle.api.file.CopyProcessingSpec">
<!--   -->
</a>
<h3>Methods inherited from interface&nbsp;org.gradle.api.file.<a href="../../../../org/gradle/api/file/CopyProcessingSpec.html" title="interface in org.gradle.api.file">CopyProcessingSpec</a></h3>
<code><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html#getDirMode()">getDirMode</a>, <a href="../../../../org/gradle/api/file/CopyProcessingSpec.html#getFileMode()">getFileMode</a>, <a href="../../../../org/gradle/api/file/CopyProcessingSpec.html#setDirMode(java.lang.Integer)">setDirMode</a>, <a href="../../../../org/gradle/api/file/CopyProcessingSpec.html#setFileMode(java.lang.Integer)">setFileMode</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_org.gradle.api.tasks.util.PatternFilterable">
<!--   -->
</a>
<h3>Methods inherited from interface&nbsp;org.gradle.api.tasks.util.<a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util">PatternFilterable</a></h3>
<code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html#getExcludes()">getExcludes</a>, <a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html#getIncludes()">getIncludes</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="isCaseSensitive()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isCaseSensitive</h4>
<pre>boolean&nbsp;isCaseSensitive()</pre>
<div class="block">Specifies whether case-sensitive pattern matching should be used.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>true for case-sensitive matching.</dd></dl>
</li>
</ul>
<a name="setCaseSensitive(boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setCaseSensitive</h4>
<pre>void&nbsp;setCaseSensitive(boolean&nbsp;caseSensitive)</pre>
<div class="block">Specifies whether case-sensitive pattern matching should be used for this CopySpec.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>caseSensitive</code> - true for case-sensitive matching.</dd></dl>
</li>
</ul>
<a name="getIncludeEmptyDirs()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getIncludeEmptyDirs</h4>
<pre>boolean&nbsp;getIncludeEmptyDirs()</pre>
<div class="block">Tells if empty target directories will be included in the copy.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd><tt>true</tt> if empty target directories will be included in the copy, <tt>false</tt> otherwise</dd></dl>
</li>
</ul>
<a name="setIncludeEmptyDirs(boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setIncludeEmptyDirs</h4>
<pre>void&nbsp;setIncludeEmptyDirs(boolean&nbsp;includeEmptyDirs)</pre>
<div class="block">Controls if empty target directories should be included in the copy.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>includeEmptyDirs</code> - <tt>true</tt> if empty target directories should be included in the copy, <tt>false</tt> otherwise</dd></dl>
</li>
</ul>
<a name="getDuplicatesStrategy()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDuplicatesStrategy</h4>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../org/gradle/api/file/DuplicatesStrategy.html" title="enum in org.gradle.api.file">DuplicatesStrategy</a>&nbsp;getDuplicatesStrategy()</pre>
<div class="block">Returns the strategy to use when trying to copy more than one file to the same destination.
 <p>
 The value can be set with a case insensitive string of the enum value (e.g. <code>'exclude'</code> for <a href="../../../../org/gradle/api/file/DuplicatesStrategy.html#EXCLUDE"><code>DuplicatesStrategy.EXCLUDE</code></a>).
 <p>
 This strategy can be overridden for individual files by using <a href="../../../../org/gradle/api/file/CopySpec.html#eachFile(org.gradle.api.Action)"><code>eachFile(org.gradle.api.Action)</code></a> or <a href="../../../../org/gradle/api/file/CopySpec.html#filesMatching(java.lang.String,%20org.gradle.api.Action)"><code>filesMatching(String, org.gradle.api.Action)</code></a>.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the strategy to use for files included by this copy spec.</dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../org/gradle/api/file/DuplicatesStrategy.html" title="enum in org.gradle.api.file"><code>DuplicatesStrategy</code></a></dd></dl>
</li>
</ul>
<a name="setDuplicatesStrategy(org.gradle.api.file.DuplicatesStrategy)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setDuplicatesStrategy</h4>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
void&nbsp;setDuplicatesStrategy(<a href="https://docs.oracle.com/javase/7/docs/api/javax/annotation/Nullable.html?is-external=true" title="class or interface in javax.annotation">@Nullable</a>
                                    <a href="../../../../org/gradle/api/file/DuplicatesStrategy.html" title="enum in org.gradle.api.file">DuplicatesStrategy</a>&nbsp;strategy)</pre>
<div class="block">The strategy to use when trying to copy more than one file to the same destination. Set to <code>null</code> to use the default strategy, which is inherited
 from the parent copy spec, if any, or <a href="../../../../org/gradle/api/file/DuplicatesStrategy.html#INCLUDE"><code>DuplicatesStrategy.INCLUDE</code></a> if this copy spec has no parent.</div>
</li>
</ul>
<a name="filesMatching(java.lang.String, org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>filesMatching</h4>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;filesMatching(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;pattern,
                                <a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file">FileCopyDetails</a>&gt;&nbsp;action)</pre>
<div class="block">Configure the <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file"><code>FileCopyDetails</code></a> for each file whose path matches the specified Ant-style pattern.
 This is equivalent to using eachFile() and selectively applying a configuration based on the file's path.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>pattern</code> - Ant-style pattern used to match against files' relative paths</dd><dd><code>action</code> - action called for the FileCopyDetails of each file matching pattern</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="filesMatching(java.lang.Iterable, org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>filesMatching</h4>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;filesMatching(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;patterns,
                                <a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file">FileCopyDetails</a>&gt;&nbsp;action)</pre>
<div class="block">Configure the <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file"><code>FileCopyDetails</code></a> for each file whose path matches any of the specified Ant-style patterns.
 This is equivalent to using eachFile() and selectively applying a configuration based on the file's path.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>patterns</code> - Ant-style patterns used to match against files' relative paths</dd><dd><code>action</code> - action called for the FileCopyDetails of each file matching pattern</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="filesNotMatching(java.lang.String, org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>filesNotMatching</h4>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;filesNotMatching(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;pattern,
                                   <a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file">FileCopyDetails</a>&gt;&nbsp;action)</pre>
<div class="block">Configure the <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file"><code>FileCopyDetails</code></a> for each file whose path does not match the specified
 Ant-style pattern. This is equivalent to using eachFile() and selectively applying a configuration based on the
 file's path.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>pattern</code> - Ant-style pattern used to match against files' relative paths</dd><dd><code>action</code> - action called for the FileCopyDetails of each file that does not match pattern</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="filesNotMatching(java.lang.Iterable, org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>filesNotMatching</h4>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;filesNotMatching(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;patterns,
                                   <a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file">FileCopyDetails</a>&gt;&nbsp;action)</pre>
<div class="block">Configure the <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file"><code>FileCopyDetails</code></a> for each file whose path does not match any of the specified
 Ant-style patterns. This is equivalent to using eachFile() and selectively applying a configuration based on the
 file's path.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>patterns</code> - Ant-style patterns used to match against files' relative paths</dd><dd><code>action</code> - action called for the FileCopyDetails of each file that does not match any pattern</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="with(org.gradle.api.file.CopySpec...)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>with</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;with(<a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>...&nbsp;sourceSpecs)</pre>
<div class="block">Adds the given specs as a child of this spec.

 <pre class='autoTested'>
 def contentSpec = copySpec {
   from("content") {
     include "**&#47;*.txt"
   }
 }

 task copy(type: Copy) {
   into "$buildDir/copy"
   with contentSpec
 }
 </pre></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>sourceSpecs</code> - The specs to add</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="from(java.lang.Object...)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>from</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;from(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>...&nbsp;sourcePaths)</pre>
<div class="block">Specifies source files or directories for a copy. The given paths are evaluated as per <a href="../../../../org/gradle/api/Project.html#files(java.lang.Object...)"><code>Project.files(Object...)</code></a>.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/file/CopySourceSpec.html#from(java.lang.Object...)">from</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/file/CopySourceSpec.html" title="interface in org.gradle.api.file">CopySourceSpec</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>sourcePaths</code> - Paths to source files for the copy</dd></dl>
</li>
</ul>
<a name="from(java.lang.Object, groovy.lang.Closure)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>from</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;from(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;sourcePath,
            <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;c)</pre>
<div class="block">Specifies the source files or directories for a copy and creates a child <code>CopySourceSpec</code>. The given source
 path is evaluated as per <a href="../../../../org/gradle/api/Project.html#files(java.lang.Object...)"><code>Project.files(Object...)</code></a> .</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/file/CopySourceSpec.html#from(java.lang.Object,%20groovy.lang.Closure)">from</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/file/CopySourceSpec.html" title="interface in org.gradle.api.file">CopySourceSpec</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>sourcePath</code> - Path to source for the copy</dd><dd><code>c</code> - closure for configuring the child CopySourceSpec</dd></dl>
</li>
</ul>
<a name="from(java.lang.Object, org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>from</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;from(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;sourcePath,
            <a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&gt;&nbsp;configureAction)</pre>
<div class="block">Specifies the source files or directories for a copy and creates a child <code>CopySpec</code>. The given source
 path is evaluated as per <a href="../../../../org/gradle/api/Project.html#files(java.lang.Object...)"><code>Project.files(Object...)</code></a> .</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/file/CopySourceSpec.html#from(java.lang.Object,%20org.gradle.api.Action)">from</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/file/CopySourceSpec.html" title="interface in org.gradle.api.file">CopySourceSpec</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>sourcePath</code> - Path to source for the copy</dd><dd><code>configureAction</code> - action for configuring the child CopySpec</dd></dl>
</li>
</ul>
<a name="setIncludes(java.lang.Iterable)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setIncludes</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;setIncludes(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;includes)</pre>
<div class="block">Set the allowable include patterns.  Note that unlike <a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html#include(java.lang.Iterable)"><code>PatternFilterable.include(Iterable)</code></a> this replaces any previously
 defined includes.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html#setIncludes(java.lang.Iterable)">setIncludes</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util">PatternFilterable</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>includes</code> - an Iterable providing new include patterns</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util"><code>Pattern Format</code></a></dd></dl>
</li>
</ul>
<a name="setExcludes(java.lang.Iterable)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setExcludes</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;setExcludes(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;excludes)</pre>
<div class="block">Set the allowable exclude patterns.  Note that unlike <a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html#exclude(java.lang.Iterable)"><code>PatternFilterable.exclude(Iterable)</code></a> this replaces any previously
 defined excludes.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html#setExcludes(java.lang.Iterable)">setExcludes</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util">PatternFilterable</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>excludes</code> - an Iterable providing new exclude patterns</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util"><code>Pattern Format</code></a></dd></dl>
</li>
</ul>
<a name="include(java.lang.String...)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>include</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;include(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>...&nbsp;includes)</pre>
<div class="block">Adds an ANT style include pattern. This method may be called multiple times to append new patterns and multiple
 patterns may be specified in a single call.

 If includes are not provided, then all files in this container will be included. If includes are provided, then a
 file must match at least one of the include patterns to be processed.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html#include(java.lang.String...)">include</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util">PatternFilterable</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>includes</code> - a vararg list of include patterns</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util"><code>Pattern Format</code></a></dd></dl>
</li>
</ul>
<a name="include(java.lang.Iterable)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>include</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;include(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;includes)</pre>
<div class="block">Adds an ANT style include pattern. This method may be called multiple times to append new patterns and multiple
 patterns may be specified in a single call.

 If includes are not provided, then all files in this container will be included. If includes are provided, then a
 file must match at least one of the include patterns to be processed.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html#include(java.lang.Iterable)">include</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util">PatternFilterable</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>includes</code> - a Iterable providing more include patterns</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util"><code>Pattern Format</code></a></dd></dl>
</li>
</ul>
<a name="include(org.gradle.api.specs.Spec)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>include</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;include(<a href="../../../../org/gradle/api/specs/Spec.html" title="interface in org.gradle.api.specs">Spec</a>&lt;<a href="../../../../org/gradle/api/file/FileTreeElement.html" title="interface in org.gradle.api.file">FileTreeElement</a>&gt;&nbsp;includeSpec)</pre>
<div class="block">Adds an include spec. This method may be called multiple times to append new specs.

 If includes are not provided, then all files in this container will be included. If includes are provided, then a
 file must match at least one of the include patterns or specs to be included.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html#include(org.gradle.api.specs.Spec)">include</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util">PatternFilterable</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>includeSpec</code> - the spec to add</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util"><code>Pattern Format</code></a></dd></dl>
</li>
</ul>
<a name="include(groovy.lang.Closure)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>include</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;include(<a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;includeSpec)</pre>
<div class="block">Adds an include spec. This method may be called multiple times to append new specs. The given closure is passed a
 <a href="../../../../org/gradle/api/file/FileTreeElement.html" title="interface in org.gradle.api.file"><code>FileTreeElement</code></a> as its parameter.

 If includes are not provided, then all files in this container will be included. If includes are provided, then a
 file must match at least one of the include patterns or specs to be included.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html#include(groovy.lang.Closure)">include</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util">PatternFilterable</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>includeSpec</code> - the spec to add</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util"><code>Pattern Format</code></a></dd></dl>
</li>
</ul>
<a name="exclude(java.lang.String...)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>exclude</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;exclude(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>...&nbsp;excludes)</pre>
<div class="block">Adds an ANT style exclude pattern. This method may be called multiple times to append new patterns and multiple
 patterns may be specified in a single call.

 If excludes are not provided, then no files will be excluded. If excludes are provided, then files must not match
 any exclude pattern to be processed.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html#exclude(java.lang.String...)">exclude</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util">PatternFilterable</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>excludes</code> - a vararg list of exclude patterns</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util"><code>Pattern Format</code></a></dd></dl>
</li>
</ul>
<a name="exclude(java.lang.Iterable)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>exclude</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;exclude(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Iterable.html?is-external=true" title="class or interface in java.lang">Iterable</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;excludes)</pre>
<div class="block">Adds an ANT style exclude pattern. This method may be called multiple times to append new patterns and multiple
 patterns may be specified in a single call.

 If excludes are not provided, then no files will be excluded. If excludes are provided, then files must not match
 any exclude pattern to be processed.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html#exclude(java.lang.Iterable)">exclude</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util">PatternFilterable</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>excludes</code> - a Iterable providing new exclude patterns</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util"><code>Pattern Format</code></a></dd></dl>
</li>
</ul>
<a name="exclude(org.gradle.api.specs.Spec)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>exclude</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;exclude(<a href="../../../../org/gradle/api/specs/Spec.html" title="interface in org.gradle.api.specs">Spec</a>&lt;<a href="../../../../org/gradle/api/file/FileTreeElement.html" title="interface in org.gradle.api.file">FileTreeElement</a>&gt;&nbsp;excludeSpec)</pre>
<div class="block">Adds an exclude spec. This method may be called multiple times to append new specs.

 If excludes are not provided, then no files will be excluded. If excludes are provided, then files must not match
 any exclude pattern to be processed.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html#exclude(org.gradle.api.specs.Spec)">exclude</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util">PatternFilterable</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>excludeSpec</code> - the spec to add</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util"><code>Pattern Format</code></a></dd></dl>
</li>
</ul>
<a name="exclude(groovy.lang.Closure)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>exclude</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;exclude(<a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;excludeSpec)</pre>
<div class="block">Adds an exclude spec. This method may be called multiple times to append new specs.The given closure is passed a
 <a href="../../../../org/gradle/api/file/FileTreeElement.html" title="interface in org.gradle.api.file"><code>FileTreeElement</code></a> as its parameter. The closure should return true or false. Example:

 <pre class='autoTested'>
 copySpec {
   from 'source'
   into 'destination'
   //an example of excluding files from certain configuration:
   exclude { it.file in configurations.someConf.files }
 }
 </pre>

 If excludes are not provided, then no files will be excluded. If excludes are provided, then files must not match
 any exclude pattern to be processed.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html#exclude(groovy.lang.Closure)">exclude</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util">PatternFilterable</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>excludeSpec</code> - the spec to add</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../org/gradle/api/tasks/util/PatternFilterable.html" title="interface in org.gradle.api.tasks.util"><code>Pattern Format</code></a></dd></dl>
</li>
</ul>
<a name="into(java.lang.Object)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>into</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;into(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;destPath)</pre>
<div class="block">Specifies the destination directory for a copy. The destination is evaluated as per <a href="../../../../org/gradle/api/Project.html#file(java.lang.Object)"><code>Project.file(Object)</code></a>.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html#into(java.lang.Object)">into</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html" title="interface in org.gradle.api.file">CopyProcessingSpec</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>destPath</code> - Path to the destination directory for a Copy</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="into(java.lang.Object, groovy.lang.Closure)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>into</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;into(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;destPath,
            <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;configureClosure)</pre>
<div class="block">Creates and configures a child <code>CopySpec</code> with the given destination path.
 The destination is evaluated as per <a href="../../../../org/gradle/api/Project.html#file(java.lang.Object)"><code>Project.file(Object)</code></a>.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>destPath</code> - Path to the destination directory for a Copy</dd><dd><code>configureClosure</code> - The closure to use to configure the child <code>CopySpec</code>.</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="into(java.lang.Object, org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>into</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;into(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;destPath,
            <a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&gt;&nbsp;copySpec)</pre>
<div class="block">Creates and configures a child <code>CopySpec</code> with the given destination path.
 The destination is evaluated as per <a href="../../../../org/gradle/api/Project.html#file(java.lang.Object)"><code>Project.file(Object)</code></a>.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>destPath</code> - Path to the destination directory for a Copy</dd><dd><code>copySpec</code> - The action to use to configure the child <code>CopySpec</code>.</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="rename(groovy.lang.Closure)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>rename</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;rename(<a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;closure)</pre>
<div class="block">Renames a source file. The closure will be called with a single parameter, the name of the file.
 The closure should return a String object with a new target name. The closure may return null,
 in which case the original name will be used.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html#rename(groovy.lang.Closure)">rename</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html" title="interface in org.gradle.api.file">CopyProcessingSpec</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>closure</code> - rename closure</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="rename(org.gradle.api.Transformer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>rename</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;rename(<a href="../../../../org/gradle/api/Transformer.html" title="interface in org.gradle.api">Transformer</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;renamer)</pre>
<div class="block">Renames a source file. The function will be called with a single parameter, the name of the file.
 The function should return a new target name. The function may return null,
 in which case the original name will be used.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html#rename(org.gradle.api.Transformer)">rename</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html" title="interface in org.gradle.api.file">CopyProcessingSpec</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>renamer</code> - rename function</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="rename(java.lang.String, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>rename</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;rename(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;sourceRegEx,
              <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;replaceWith)</pre>
<div class="block">Renames files based on a regular expression.  Uses java.util.regex type of regular expressions.  Note that the
 replace string should use the '$1' syntax to refer to capture groups in the source regular expression.  Files
 that do not match the source regular expression will be copied with the original name.

 <p> Example:
 <pre>
 rename '(.*)_OEM_BLUE_(.*)', '$1$2'
 </pre>
 would map the file 'style_OEM_BLUE_.css' to 'style.css'</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html#rename(java.lang.String,%20java.lang.String)">rename</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html" title="interface in org.gradle.api.file">CopyProcessingSpec</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>sourceRegEx</code> - Source regular expression</dd><dd><code>replaceWith</code> - Replacement string (use $ syntax for capture groups)</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="rename(java.util.regex.Pattern, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>rename</h4>
<pre><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html" title="interface in org.gradle.api.file">CopyProcessingSpec</a>&nbsp;rename(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/regex/Pattern.html?is-external=true" title="class or interface in java.util.regex">Pattern</a>&nbsp;sourceRegEx,
                        <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;replaceWith)</pre>
<div class="block">Renames files based on a regular expression. See <a href="../../../../org/gradle/api/file/CopyProcessingSpec.html#rename(java.lang.String,%20java.lang.String)"><code>CopyProcessingSpec.rename(String, String)</code></a>.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html#rename(java.util.regex.Pattern,%20java.lang.String)">rename</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html" title="interface in org.gradle.api.file">CopyProcessingSpec</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>sourceRegEx</code> - Source regular expression</dd><dd><code>replaceWith</code> - Replacement string (use $ syntax for capture groups)</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="filter(java.util.Map, java.lang.Class)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>filter</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;filter(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,?&gt;&nbsp;properties,
              <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="https://docs.oracle.com/javase/7/docs/api/java/io/FilterReader.html?is-external=true" title="class or interface in java.io">FilterReader</a>&gt;&nbsp;filterType)</pre>
<div class="block"><p>Adds a content filter to be used during the copy.  Multiple calls to filter, add additional filters to the
 filter chain.  Each filter should implement <code>java.io.FilterReader</code>. Include <code>org.apache.tools.ant.filters.*</code> for access to all the standard Ant filters.</p>

 <p>Filter properties may be specified using groovy map syntax.</p>

 <p> Examples:
 <pre>
    filter(HeadFilter, lines:25, skip:2)
    filter(ReplaceTokens, tokens:[copyright:'2009', version:'2.3.1'])
 </pre></div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/file/ContentFilterable.html#filter(java.util.Map,%20java.lang.Class)">filter</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/file/ContentFilterable.html" title="interface in org.gradle.api.file">ContentFilterable</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>properties</code> - map of filter properties</dd><dd><code>filterType</code> - Class of filter to add</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="filter(java.lang.Class)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>filter</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;filter(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends <a href="https://docs.oracle.com/javase/7/docs/api/java/io/FilterReader.html?is-external=true" title="class or interface in java.io">FilterReader</a>&gt;&nbsp;filterType)</pre>
<div class="block"><p>Adds a content filter to be used during the copy.  Multiple calls to filter, add additional filters to the
 filter chain.  Each filter should implement <code>java.io.FilterReader</code>. Include <code>org.apache.tools.ant.filters.*</code> for access to all the standard Ant filters.</p>

 <p> Examples:
 <pre>
    filter(StripJavaComments)
    filter(com.mycompany.project.CustomFilter)
 </pre></div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/file/ContentFilterable.html#filter(java.lang.Class)">filter</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/file/ContentFilterable.html" title="interface in org.gradle.api.file">ContentFilterable</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>filterType</code> - Class of filter to add</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="filter(groovy.lang.Closure)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>filter</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;filter(<a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;closure)</pre>
<div class="block">Adds a content filter based on the provided closure.  The Closure will be called with each line (stripped of line
 endings) and should return a String to replace the line or <code>null</code> to remove the line.  If every line is
 removed, the result will be an empty file, not an absent one.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/file/ContentFilterable.html#filter(groovy.lang.Closure)">filter</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/file/ContentFilterable.html" title="interface in org.gradle.api.file">ContentFilterable</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>closure</code> - to implement line based filtering</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="filter(org.gradle.api.Transformer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>filter</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;filter(<a href="../../../../org/gradle/api/Transformer.html" title="interface in org.gradle.api">Transformer</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;transformer)</pre>
<div class="block">Adds a content filter based on the provided transformer.  The Closure will be called with each line (stripped of line
 endings) and should return a String to replace the line or <code>null</code> to remove the line.  If every line is
 removed, the result will be an empty file, not an absent one.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/file/ContentFilterable.html#filter(org.gradle.api.Transformer)">filter</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/file/ContentFilterable.html" title="interface in org.gradle.api.file">ContentFilterable</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>transformer</code> - to implement line based filtering</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="expand(java.util.Map)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>expand</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;expand(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,?&gt;&nbsp;properties)</pre>
<div class="block"><p>Expands property references in each file as it is copied. More specifically, each file is transformed using
 Groovy's <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/text/SimpleTemplateEngine.html?is-external=true" title="class or interface in groovy.text"><code>SimpleTemplateEngine</code></a>. This means you can use simple property references, such as
 <code>$property</code> or <code>${property}</code> in the file. You can also include arbitrary Groovy code in the
 file, such as <code>${version ?: 'unknown'}</code> or <code>${classpath*.name.join(' ')}</code></div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/file/ContentFilterable.html#expand(java.util.Map)">expand</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/file/ContentFilterable.html" title="interface in org.gradle.api.file">ContentFilterable</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>properties</code> - to implement line based filtering</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="eachFile(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>eachFile</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;eachFile(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file">FileCopyDetails</a>&gt;&nbsp;action)</pre>
<div class="block">Adds an action to be applied to each file as it is about to be copied into its destination. The action can change
 the destination path of the file, filter the contents of the file, or exclude the file from the result entirely.
 Actions are executed in the order added, and are inherited from the parent spec.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html#eachFile(org.gradle.api.Action)">eachFile</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html" title="interface in org.gradle.api.file">CopyProcessingSpec</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>action</code> - The action to execute.</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="eachFile(groovy.lang.Closure)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>eachFile</h4>
<pre><a href="../../../../org/gradle/api/file/CopySpec.html" title="interface in org.gradle.api.file">CopySpec</a>&nbsp;eachFile(<a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;closure)</pre>
<div class="block">Adds an action to be applied to each file as it about to be copied into its destination. The given closure is
 called with a <a href="../../../../org/gradle/api/file/FileCopyDetails.html" title="interface in org.gradle.api.file"><code>FileCopyDetails</code></a> as its parameter. Actions are executed in the order
 added, and are inherited from the parent spec.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html#eachFile(groovy.lang.Closure)">eachFile</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../org/gradle/api/file/CopyProcessingSpec.html" title="interface in org.gradle.api.file">CopyProcessingSpec</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>closure</code> - The action to execute.</dd>
<dt><span class="strong">Returns:</span></dt><dd>this</dd></dl>
</li>
</ul>
<a name="getFilteringCharset()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getFilteringCharset</h4>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;getFilteringCharset()</pre>
<div class="block">Gets the charset used to read and write files when filtering.
 By default, the JVM default charset is used.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the charset used to read and write files when filtering</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.14</dd></dl>
</li>
</ul>
<a name="setFilteringCharset(java.lang.String)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>setFilteringCharset</h4>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
void&nbsp;setFilteringCharset(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;charset)</pre>
<div class="block">Specifies the charset used to read and write files when filtering.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>charset</code> - the name of the charset to use when filtering files</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.14</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/file/CopySourceSpec.html" title="interface in org.gradle.api.file"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/file/DeleteSpec.html" title="interface in org.gradle.api.file"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/file/CopySpec.html" target="_top">Frames</a></li>
<li><a href="CopySpec.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
